package 
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.system.LoaderContext;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.getDefinitionByName;
	
/* * * * * * * * * *
*                  *
*  @author wolsh   *
*                  *
\* * * * * * * * * */ 

/*                                                                                                                           
 *  Сначала надо скомпилить набор плагинских классов. Для этого выбираем класс документа – Figures.as и запускаем компиляцию.
 *  Переименовываем полученный swf в Figures.swf                                                                             
 *  Этот файл теперь содержит классы Triangle.as, Circle.as и Quadrat.as                                                     
 *  Теперь компилим основную флэшку. Выбираем класс документа – Main.as и запускаем компиляцию.                              
 *                                                                                                                          */
	public class Main extends Sprite 
	{
		private var _pluginKit:Sprite;
		private var _pluginsXML:XML;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			//// Грузим XML с описаниями доступных плагинов
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, handlerXMLLoaded);
			xmlLoader.load(new URLRequest("plugins.xml"));
		}
		
		private function handlerXMLLoaded(event:Event):void 
		{
			_pluginsXML = XML((event.currentTarget as URLLoader).data);
			//// Грузим swf с плагинами
			var request:URLRequest = new URLRequest(_pluginsXML.url);
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, handlerPluginsLoaded);
			//// важно: грузим в общий домен
			loader.load(request, new LoaderContext(false, this.loaderInfo.applicationDomain));
		}
		
		//// сохраняем набор загруженных плагинов в переменной и создаем меню выбора плагина
		private function handlerPluginsLoaded(event:Event):void 
		{
			_pluginKit = (event.currentTarget as LoaderInfo).content as Sprite;
			createMenu();
		}
		
		//// создает меню загруженных плагинов
		private function createMenu():void 
		{
			//// список текстовых имен плагинов, которые будут отображаться на кнопках меню
			var labelList:XMLList = _pluginsXML..description;
			//// создаем и размещаем кнопки
			var h:uint = 0;
			for each (var descript:XML in labelList)
			{
				var button:Sprite = createMenuButton(descript.text());
				button.name = h.toString(); // идентификатор, номер узла
				this.addChild(button);
				button.x = 500;
				button.y = 200 + h++ * 32;
				button.addEventListener(MouseEvent.CLICK, handlerPluginSelect);
			}
		}
		
		//// создает кнопку для меню загруженных плагинов
		private function createMenuButton(label:String):Sprite 
		{
			var s:Sprite = new Sprite();
			s.graphics.beginFill(0x444444);
			s.graphics.drawRoundRect(0, 0, 150, 30, 8);
			var txt:TextField = new TextField();
			txt.defaultTextFormat = new TextFormat("Arial", 16, 0xFFFFFF);
			txt.text = label;
			txt.width = txt.textWidth + 4;
			txt.height = txt.textHeight + 4;
			txt.x = (150 - txt.width) / 2;
			txt.y = (30 - txt.height) / 2;
			s.addChild(txt);
			s.mouseChildren = false;
			return s;
		}
		
		//// применяем выбранный плагин
		private function handlerPluginSelect(event:MouseEvent):void 
		{
			//// соответствие кнопки и описания плагина в XML
			var pluginIndex:uint = uint((event.currentTarget as Sprite).name);
			//// получаем из XML имя класса плагина соотв. нажатой кнопке
			var pluginName:String = _pluginsXML..plugin[pluginIndex].className.text();
			//// создаем экземпляр плагина
			var plug:IPlugin = new (getDefinitionByName(pluginName) as Class)();
			//// запускаем метод плагина и получаем фигуру
			var shape:Shape = plug.figure;
			//// добавляем плагинскую фигуру в список отображения
			addChild(shape);
			shape.alpha = .25;
			shape.x = shape.y = 100;
		}
		
	}
	
}